<template>
  <div>
    <el-breadcrumb separator=">">
      <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="#">生产加工</a>
      </el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="/base/work">加工单</a>
      </el-breadcrumb-item>
    </el-breadcrumb>
    <el-divider></el-divider>
    <!--
      要resetFields起作用，必须配置:model和prop
    -->
    <el-form ref="queryForm" :model="queryModel" inline class="demo-form-inline">
      <el-form-item label="客户" prop="customerId">
        <el-select size="mini" v-model="queryModel.customerId" filterable>
          <el-option v-for="customer in customerList" :key="customer.id" :label="customer.company" :value="customer.id"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="编号" prop="number">
        <el-input type="text" size="mini" v-model="queryModel.number"></el-input>
      </el-form-item>
      <el-form-item label="品种及规格" prop="name">
        <el-input type="text" size="mini" v-model="queryModel.name"></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" size="mini" icon="ios-search" @click="changePage(1)"
          :loading="loading">查询</el-button>&nbsp;
        <el-button type="info" size="mini" style="margin-left: 8px" @click="handleReset('queryForm')">重置</el-button>&nbsp;
      </el-form-item>
    </el-form>
    <el-divider></el-divider>
    <el-row class="button-group">
      <el-button type="primary" size="small" plain icon="el-icon-circle-plus" @click="handleAdd">新增</el-button>
      <el-button type="primary" size="small" plain icon="el-icon-remove" :disabled="multipleSelection.length == 0" @click="handleBatchDelete">删除选中项</el-button>
    </el-row>
    <el-table :data="tableData" style="min-height:400px;" v-loading="loading" stripe @sort-change="sortChange" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column prop="customerName" label="客户" width="180"></el-table-column>
      <el-table-column prop="number" label="编号" width="180"></el-table-column>
      <el-table-column prop="name" label="品种及规格" width="180"></el-table-column>
      <el-table-column prop="width" label="幅宽" width="180"></el-table-column>
      <el-table-column prop="processDate" label="投坯日" width="180"></el-table-column>
      <el-table-column prop="processVolume" label="投坯数" width="180"></el-table-column>
      <el-table-column prop="ratio" label="伸长率" width="180"></el-table-column>
      <el-table-column prop="colour" label="色泽" width="180"></el-table-column>
      <el-table-column prop="estimateQuantity" label="应交成品数" width="180"></el-table-column>
      <el-table-column prop="unitPrice" label="单价" width="180"></el-table-column>
      <el-table-column prop="reason" label="原因" width="180"></el-table-column>
      <el-table-column prop="clothPrice" label="坯布价" width="180"></el-table-column>
      <el-table-column prop="wages" label="力资（元/卷）" width="180"></el-table-column>
      <el-table-column prop="remark" label="备注"></el-table-column>
      <el-table-column label="操作" fixed="right" width="210px">
        <template slot-scope="{row}">
          <el-button v-if="row.haveBills == false" size="mini" type="info" @click="handleBill(row)">账单</el-button>
          <el-button v-if="row.haveBills == false" size="mini" type="warning" @click="handleEdit(row)">编辑</el-button>
          <el-button v-if="row.haveBills == false" size="mini" type="danger" @click="handleDelete(row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination :current-page.sync="pageIndex" :total="totalElements" :page-sizes="pageSizeList" @current-change="changePage" @size-change="pageSizeChange" layout="total, sizes, prev, pager, next, jumper"></el-pagination>
    <work-detail v-if="showModal" :businessKey="businessKey" :title="modalTitle" @close="onDetailModalClose"></work-detail>
    <work-bill v-if="showBill" :businessKey="businessKey" :title="modalTitle" @close="onDetailModalClose"></work-bill>
  </div>
</template>
<script>
import Constant from "@/constant";
import WorkDetail from "./work-detail";
import WorkBill from "./work-bill";
import workApi from "@/api/base/work";
import customerApi from "@/api/base/customer";
import NProgress from "nprogress"; // progress bar
import "nprogress/nprogress.css"; // progress bar style

export default {
  data() {
    var self = this;

    return {
      queryModel: {
        "customerId": "",
        "name": "",
        "number": ""
      },
      loading: false,
      tableData: [],
      pageIndex: 1,
      pageSize: 10,
      totalPages: 0,
      totalElements: 0,
      field: "",
      direction: "",
      pageSizeList: [10, 20, 30],
      multipleSelection: [],
      showModal: false,
      showBill: false,
      modalTitle: "",
      businessKey: "",
      customerList: [],
    };
  },
  methods: {
    changePage(pageIndex) {
      var self = this;

      self.loading = true;

      self.pageIndex = pageIndex;
      var formData = new FormData();

      formData.append("pageIndex", self.pageIndex);
      formData.append("pageSize", self.pageSize);

      formData.append("customerId", self.queryModel.customerId);
      formData.append("name", self.queryModel.name);
      formData.append("number", self.queryModel.number);

      workApi.pageList(formData).then(function (response) {
        self.loading = false;

        var jsonData = response.data.data;

        self.tableData = jsonData.data;
        self.totalPages = jsonData.totalPages;
        self.totalElements = jsonData.recordsTotal;
      }).catch((error) => {
        self.loading = false;
        // self.$message.error(error + "");
      });
    },
    pageSizeChange(pageSize) {
      this.pageSize = pageSize;

      this.$nextTick(() => {
        this.changePage(this.pageIndex);
      });
    },
    sortChange(data) {
      this.field = data.column.field;
      this.direction = data.order;

      this.changePage(this.pageIndex);
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleReset(name) {
      this.$refs[name].resetFields();
    },
    handleAdd() {
      this.modalTitle = "新增";
      this.businessKey = "";
      this.showModal = true;
    },
    handleEdit(record) {
      this.modalTitle = "编辑";
      this.businessKey = record.id;
      this.showModal = true;
    },
    handleBill(record) {
      this.modalTitle = "账单";
      this.businessKey = record.id;
      this.showBill = true;
    },
    handleDelete(record) {
      var self = this;

      self.$confirm("是否确认删除?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(() => {
        workApi.remove(record.id).then(function (response) {
          var jsonData = response.data;

          if (jsonData.result) {
            // var index = self.tableData.indexOf(record);
            // self.tableData.splice(index, 1);
            self.changePage(self.pageIndex);

            self.$message({
              type: "success",
              message: "删除成功!"
            });
          }
        });
      });
    },
    handleBatchDelete() {
      var self = this;

      var idList = this.multipleSelection.map(record => {
        return record.id;
      });

      this.$confirm("是否确认删除选中项？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(() => {
        workApi.batchRemove(idList).then(function (response) {
          var jsonData = response.data;

          if (jsonData.result) {
            self.changePage(self.pageIndex);

            self.$message({
              type: "success",
              message: "删除成功!"
            });
          }
        });
      });
    },
    onDetailModalClose(refreshed) {
      this.showModal = false;
      this.showBill = false;

      if (refreshed) {
        this.changePage(this.pageIndex);
      }
    }
  },
  mounted: function () {
    customerApi.findList().then(response => {
      this.customerList = response.data.data;
    });

    this.changePage(1);
  },
  components: {
    "work-detail": WorkDetail,
    "work-bill": WorkBill
  }
};
</script>
<style lang="scss" scoped>
.el-breadcrumb {
  margin: 10px;
  line-height: 20px;
}

.el-divider {
  margin: 5px 0;
}

.demo-form-inline {
  margin-left: 10px;
  text-align: left;
}

.button-group {
  margin-left: 10px;
  text-align: left;
}
</style>